
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>快速入门Java中的Lambda表达式_java / iVAN</title>

    <meta name="description" content="快速入门Java中的Lambda表达式_java Lambda简介 Lambda表达式是Java SE 8中一个重要的新特性.lambda表达式允许你通过表达式来代替功能接口. lambda表达式就和方法一样,它提供了一个正常的参数列表和一个使用这些参数的主体(body,可以是一个表达式或一个代码块). Lambda表达式还增强了集合库. Java SE 8添加了2个对集合数据进行批量操作的包: java.util.function 包以及 java.util.stream 包. 流(stream)就如同迭代器(iterator),但附加了许多">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">快速入门Java中的Lambda表达式_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>Lambda简介</strong></p>
<p>Lambda表达式是Java SE 8中一个重要的新特性。lambda表达式允许你通过表达式来代替功能接口。 lambda表达式就和方法一样,它提供了一个正常的参数列表和一个使用这些参数的主体(body,可以是一个表达式或一个代码块)。</p>
<p>Lambda表达式还增强了集合库。 Java SE 8添加了2个对集合数据进行批量操作的包:<code> java.util.function </code>包以及 <code>java.util.stream </code>包。 流(stream)就如同迭代器(iterator),但附加了许多额外的功能。 总的来说,lambda表达式和 stream 是自Java语言添加泛型(Generics)和注解(annotation)以来最大的变化。</p>
<p>Lambda表达式本质上是匿名方法，其底层还是通过<code>invokedynamic</code>指令来生成匿名类来实现。它提供了更为简单的语法和写作方式，允许你通过表达式来代替函数式接口。在一些人看来，Lambda就是可以让你的代码变得更简洁，完全可以不使用——这种看法当然没问题，但重要的是lambda为Java带来了闭包。得益于Lamdba对集合的支持，通过Lambda在多核处理器条件下对集合遍历时的性能提高极大，另外我们可以以数据流的方式处理集合——这是非常有吸引力的。</p>
<p><strong>Lambda语法</strong></p>
<p>Lambda的语法极为简单，类似如下结构:</p>
<pre>
(parameters) -&gt; expression</pre>
<p>或者</p>
<pre>
(parameters) -&gt; { statements; }</pre>
<p><strong>Lambda表达式由三部分组成：</strong></p>
<p><strong>      1、paramaters：</strong>类似方法中的形参列表，这里的参数是函数式接口里的参数。这里的参数类型可以明确的声明也可不声明而由JVM隐含的推断。另外当只有一个推断类型时可以省略掉圆括号。</p>
<p>      <strong>2、-&gt;：</strong>可理解为“被用于”的意思</p>
<p>      <strong>3、方法体：</strong>可以是表达式也可以代码块，是函数式接口里方法的实现。代码块可返回一个值或者什么都不反回，这里的代码块块等同于方法的方法体。如果是表达式，也可以返回一个值或者什么都不反回。</p>
<p>我们通过以下几个示例来做说明：</p>
<pre>
//示例1：不需要接受参数，直接返回10
()-&gt;10

//示例2：接受两个int类型的参数，并返回这两个参数相加的和
(int x,int y)-&gt;x+y;

//示例2：接受x,y两个参数，该参数的类型由JVM根据上下文推断出来，并返回两个参数的和
(x,y)-&gt;x+y;

//示例3：接受一个字符串，并将该字符串打印到控制到，不反回结果
(String name)-&gt;System.out.println(name);

//示例4：接受一个推断类型的参数name，并将该字符串打印到控制台
name-&gt;System.out.println(name);

//示例5：接受两个String类型参数，并分别输出，不反回
(String name,String sex)-&gt;{System.out.println(name);System.out.println(sex)}

//示例6：接受一个参数x，并返回该该参数的两倍
x-&gt;2*x</pre>
<p><strong>Lambda用在哪里</strong></p>
<p>在[函数式接口][1]中我们知道Lambda表达式的目标类型是函数性接口——每一个Lambda都能通过一个特定的函数式接口与一个给定的类型进行匹配。因此一个Lambda表达式能被应用在与其目标类型匹配的任何地方，lambda表达式必须和函数式接口的抽象函数描述一样的参数类型，它的返回类型也必须和抽象函数的返回类型兼容，并且他能抛出的异常也仅限于在函数的描述范围中。</p>
<p>接下来，我们看一个自定义的函数式接口示例：</p>
<pre>
 @FunctionalInterface
 interface Converter&lt;F, T&gt;{

   T convert(F from);

}</pre>
<p>首先用传统的方式来使用该接口：</p>
<pre>
 Converter&lt;String ,Integer&gt; converter=new Converter&lt;String, Integer&gt;() {
      @Override
      public Integer convert(String from) {
        return Integer.valueOf(from);
      }
    };

    Integer result = converter.convert("200");
    System.out.println(result);</pre>
<p>很显然这没任何问题，那么接下里就是Lambda上场的时刻，用Lambda实现Converter接口：</p>
<pre>
Converter&lt;String ,Integer&gt; converter=(param) -&gt; Integer.valueOf(param);
    Integer result = converter.convert("101");
    System.out.println(result);</pre>
<p>通过上例，我想你已经对Lambda的使用有了个简单的认识，下面，我们在用一个常用的Runnable做演示：</p>
<p>在以前我们可能会写下这种代码：</p>
<pre>
new Thread(new Runnable() {
      @Override
      public void run() {
        System.out.println("hello lambda");
      }
    }).start();</pre>
<p>在某些情况下，大量的匿名类会让代码显得杂乱无章。现在可以用Lambda来使它变得简洁：</p>
<pre>
new Thread(() -&gt; System.out.println("hello lambda")).start();</pre>
<p><strong>方法引用</strong></p>
<p>方法引用是Lambda表达式的一个简化写法。所引用的方法其实是Lambda表达式的方法体的实现，其语法结构为:</p>
<pre>
ObjectRef::methodName</pre>
<p>左边可以是类名或者实例名，中间是方法引用符号”::”，右边是相应的方法名。</p>
<p><strong>方法引用被分为三类：</strong></p>
<p><strong>1. 静态方法引用</strong></p>
<p>在某些情况下，我们可能写出这样的代码：</p>
<pre>
public class ReferenceTest {
  public static void main(String[] args) {
    Converter&lt;String ,Integer&gt; converter=new Converter&lt;String, Integer&gt;() {
      @Override
      public Integer convert(String from) {
        return ReferenceTest.String2Int(from);
      }
    };
    converter.convert("120");

  }

  @FunctionalInterface
  interface Converter&lt;F,T&gt;{
    T convert(F from);
  }

  static int String2Int(String from) {
    return Integer.valueOf(from);
  }
}</pre>
<p>这时候如果用静态引用会使的代码更加简洁：</p>
<pre>
 Converter&lt;String, Integer&gt; converter = ReferenceTest::String2Int;
 converter.convert("120");</pre>
<p><strong>2. 实例方法引用</strong></p>
<p>我们也可能会写下这样的代码：</p>
<pre>
public class ReferenceTest {
  public static void main(String[] args) {

    Converter&lt;String, Integer&gt; converter = new Converter&lt;String, Integer&gt;() {
      @Override
      public Integer convert(String from) {
        return new Helper().String2Int(from);
      }
    };
    converter.convert("120");
  }

  @FunctionalInterface
  interface Converter&lt;F, T&gt; {
    T convert(F from);
  }

  static class Helper {
    public int String2Int(String from) {
      return Integer.valueOf(from);
    }
  }
}</pre>
<p>同样用实例方法引用会显得更加简洁：</p>
<pre>
 Helper helper = new Helper();
 Converter&lt;String, Integer&gt; converter = helper::String2Int;
 converter.convert("120");</pre>
<p><strong>3. 构造方法引用</strong></p>
<p>现在我们来演示构造方法的引用。首先我们定义一个父类Animal:</p>
<pre>
  class Animal{
    private String name;
    private int age;

    public Animal(String name, int age) {
      this.name = name;
      this.age = age;
    }

    public void behavior(){

    }
  }</pre>
<p>接下来，我们在定义两个Animal的子类：<code>Dog、Bird</code></p>
<pre>
public class Bird extends Animal {

  public Bird(String name, int age) {
    super(name, age);
  }

  @Override
  public void behavior() {
    System.out.println("fly");
  }
}

class Dog extends Animal {

  public Dog(String name, int age) {
    super(name, age);
  }

  @Override
  public void behavior() {
    System.out.println("run");
  }
}</pre>
<p>随后我们定义工厂接口：</p>
<pre>
  interface Factory&lt;T extends Animal&gt; {
    T create(String name, int age);
  }</pre>
<p>接下来我们还是用传统的方法来创建Dog类和Bird类的对象：</p>
<pre>
    Factory factory=new Factory() {
      @Override
      public Animal create(String name, int age) {
        return new Dog(name,age);
      }
    };
    factory.create("alias", 3);
    factory=new Factory() {
      @Override
      public Animal create(String name, int age) {
        return new Bird(name,age);
      }
    };
    factory.create("smook", 2);</pre>
<p>仅仅为了创建两个对象就写了十多号代码，现在我们用构造函数引用试试：</p>
<pre>
 Factory&lt;Animal&gt; dogFactory =Dog::new;
 Animal dog = dogFactory.create("alias", 4);

 Factory&lt;Bird&gt; birdFactory = Bird::new;
 Bird bird = birdFactory.create("smook", 3);
</pre>
<p>这样代码就显得干净利落了。通过<code>Dog::new</code>这种方式来穿件对象时，<code>Factory.create</code>函数的签名选择相应的造函数。</p>
<p><strong>Lambda的域以及访问限制</strong></p>
<p>域即作用域，Lambda表达式中的参数列表中的参数在该Lambda表达式范围内（域）有效。在作用Lambda表达式内，可以访问外部的变量：局部变量、类变量和静态变量，但操作受限程度不一。</p>
<p><strong>访问局部变量</strong></p>
<p>在Lambda表达式外部的局部变量会被JVM隐式的编译成final类型，因此只能访问外而不能修改。</p>
<pre>
public class ReferenceTest {
  public static void main(String[] args) {

    int n = 3;
    Calculate calculate = param -&gt; {
      //n=10; 编译错误
      return n + param;
    };
    calculate.calculate(10);
  }

  @FunctionalInterface
  interface Calculate {
    int calculate(int value);
  }

}</pre>
<p><strong>访问静态变量和成员变量</strong></p>
<p>在Lambda表达式内部，对静态变量和成员变量可读可写。</p>
<pre>
public class ReferenceTest {
  public int count = 1;
  public static int num = 2;

  public void test() {
    Calculate calculate = param -&gt; {
      num = 10;//修改静态变量
      count = 3;//修改成员变量
      return n + param;
    };
    calculate.calculate(10);
  }

  public static void main(String[] args) {

  }

  @FunctionalInterface
  interface Calculate {
    int calculate(int value);
  }

}</pre>
<p><strong>Lambda不能访问函数接口的默认方法</strong></p>
<p>java8增强了接口，其中包括接口可添加default关键词定义的默认方法，这里我们需要注意，Lambda表达式内部不支持访问默认方法。</p>
<p><strong>Lambda实践</strong></p>
<p>在[函数式接口][2]一节中，我们提到<code>java.util.function</code>包中内置许多函数式接口，现在将对常用的函数式接口做说明。</p>
<p><strong>Predicate接口</strong></p>
<p>输入一个参数，并返回一个<code>Boolean</code>值，其中内置许多用于逻辑判断的默认方法:</p>
<pre>
  @Test
  public void predicateTest() {
    Predicate&lt;String&gt; predicate = (s) -&gt; s.length() &gt; 0;
    boolean test = predicate.test("test");
    System.out.println("字符串长度大于0:" + test);

    test = predicate.test("");
    System.out.println("字符串长度大于0:" + test);

    test = predicate.negate().test("");
    System.out.println("字符串长度小于0:" + test);

    Predicate&lt;Object&gt; pre = Objects::nonNull;
    Object ob = null;
    test = pre.test(ob);
    System.out.println("对象不为空:" + test);
    ob = new Object();
    test = pre.test(ob);
    System.out.println("对象不为空:" + test);
  }</pre>
<p><strong>Function接口</strong></p>
<p>接收一个参数，返回单一的结果，默认的方法（<code>andThen</code>）可将多个函数串在一起，形成复合<code>Funtion</code>（有输入，有输出）结果，</p>
<pre>
  @Test
  public void functionTest() {
    Function&lt;String, Integer&gt; toInteger = Integer::valueOf;
    //toInteger的执行结果作为第二个backToString的输入
    Function&lt;String, String&gt; backToString = toInteger.andThen(String::valueOf);
    String result = backToString.apply("1234");
    System.out.println(result);

    Function&lt;Integer, Integer&gt; add = (i) -&gt; {
      System.out.println("frist input:" + i);
      return i * 2;
    };
    Function&lt;Integer, Integer&gt; zero = add.andThen((i) -&gt; {
      System.out.println("second input:" + i);
      return i * 0;
    });

    Integer res = zero.apply(8);
    System.out.println(res);
  }</pre>
<p><strong>Supplier接口</strong></p>
<p>返回一个给定类型的结果，与<code>Function</code>不同的是，<code>Supplier</code>不需要接受参数(供应者，有输出无输入)</p>
<pre>
  @Test
  public void supplierTest() {
    Supplier&lt;String&gt; supplier = () -&gt; "special type value";
    String s = supplier.get();
    System.out.println(s);
  }</pre>
<p><strong>Consumer接口</strong></p>
<p>代表了在单一的输入参数上需要进行的操作。和<code>Function</code>不同的是，<code>Consumer</code>没有返回值(消费者，有输入，无输出)</p>
<pre>
  @Test
  public void consumerTest() {
    Consumer&lt;Integer&gt; add5 = (p) -&gt; {
      System.out.println("old value:" + p);
      p = p + 5;
      System.out.println("new value:" + p);
    };
    add5.accept(10);
  }</pre>
<p>以上四个接口的用法代表了<code>java.util.function</code>包中四种类型，理解这四个函数式接口之后，其他的接口也就容易理解了，现在我们来做一下简单的总结：</p>
<p><code>Predicate</code>用来逻辑判断，<code>Function</code>用在有输入有输出的地方，<code>Supplier</code>用在无输入，有输出的地方，而<code>Consumer</code>用在有输入，无输出的地方。你大可通过其名称的含义来获知其使用场景。</p>
<p><strong>Stream</strong></p>
<p>Lambda为java8带了闭包，这一特性在集合操作中尤为重要：java8中支持对集合对象的stream进行函数式操作，此外，stream api也被集成进了collection api，允许对集合对象进行批量操作。</p>
<p><strong>下面我们来认识Stream。</strong></p>
<p>Stream表示数据流，它没有数据结构，本身也不存储元素，其操作也不会改变源Stream，而是生成新Stream.作为一种操作数据的接口，它提供了过滤、排序、映射、规约等多种操作方法，这些方法按照返回类型被分为两类：凡是返回Stream类型的方法，称之为中间方法（中间操作），其余的都是完结方法（完结操作）。完结方法返回一个某种类型的值，而中间方法则返回新的Stream。中间方法的调用通常是链式的，该过程会形成一个管道，当完结方法被调用时会导致立即从管道中消费值，这里我们要记住：Stream的操作尽可能以“延迟”的方式运行，也就是我们常说的“懒操作”，这样有助于减少资源占用，提高性能。对于所有的中间操作（除sorted外）都是运行在延迟模式下。</p>
<p>Stream不但提供了强大的数据操作能力，更重要的是Stream既支持串行也支持并行，并行使得Stream在多核处理器上有着更好的性能。</p>
<p><strong>Stream的使用过程有着固定的模式：</strong></p>
<p>      1、创建Stream</p>
<p>      2、通过中间操作，对原始Stream进行“变化”并生成新的Stream</p>
<p>      3、使用完结操作，生成最终结果</p>
<p>也就是</p>
<p><strong>      创建——&gt;变化——&gt;完结</strong></p>
<p><strong>Stream的创建</strong></p>
<p>对于集合来说，可以通过调用集合的<code>stream()</code>或者<code>parallelStream()</code>来创建，另外这两个方法也在Collection接口中实现了。对于数组来说，可以通过Stream的静态方法<code>of(T … values)</code>来创建，另外，Arrays也提供了有关stream的支持。</p>
<p>除了以上基于集合或者数组来创建Stream,也可以通过<code>Steam.empty()</code>创建空的Stream,或者利用Stream的<code>generate（）</code>来创建无穷的Stream。</p>
<p>下面我们以串行Stream为例，分别说明Stream几种常用的中间方法和完结方法。首先创建一个List集合：</p>
<pre>
List&lt;String&gt; lists=new ArrayList&lt;String &gt;();
    lists.add("a1");
    lists.add("a2");
    lists.add("b1");
    lists.add("b2");
    lists.add("b3");
    lists.add("o1");</pre>
<p><strong>中间方法</strong></p>
<p><strong>过滤器（Filter）</strong></p>
<p>结合Predicate接口，Filter对流对象中的所有元素进行过滤,该操作是一个中间操作，这意味着你可以在操作返回结果的基础上进行其他操作。</p>
<pre>
  public static void streamFilterTest() {
    lists.stream().filter((s -&gt; s.startsWith("a"))).forEach(System.out::println);

    //等价于以上操作
    Predicate&lt;String&gt; predicate = (s) -&gt; s.startsWith("a");
    lists.stream().filter(predicate).forEach(System.out::println);

    //连续过滤
    Predicate&lt;String&gt; predicate1 = (s -&gt; s.endsWith("1"));
    lists.stream().filter(predicate).filter(predicate1).forEach(System.out::println);
  }</pre>
<p><strong>排序（Sorted）</strong></p>
<p>结合Comparator接口，该操作返回一个排序过后的流的视图，原始流的顺序不会改变。通过Comparator来指定排序规则，默认是按照自然顺序排序。</p>
<pre>
   public static void streamSortedTest() {
    System.out.println("默认Comparator");
    lists.stream().sorted().filter((s -&gt; s.startsWith("a"))).forEach(System.out::println);

    System.out.println("自定义Comparator");
    lists.stream().sorted((p1, p2) -&gt; p2.compareTo(p1)).filter((s -&gt; s.startsWith("a"))).forEach(System.out::println);

  }</pre>
<p><strong>映射（Map）</strong></p>
<p>结合<code>Function</code>接口，该操作能将流对象中的每个元素映射为另一种元素，实现元素类型的转换。</p>
<pre>
  public static void streamMapTest() {
    lists.stream().map(String::toUpperCase).sorted((a, b) -&gt; b.compareTo(a)).forEach(System.out::println);

    System.out.println("自定义映射规则");
    Function&lt;String, String&gt; function = (p) -&gt; {
      return p + ".txt";
    };
    lists.stream().map(String::toUpperCase).map(function).sorted((a, b) -&gt; b.compareTo(a)).forEach(System.out::println);

  }</pre>
<p>在上面简单介绍了三种常用的操作，这三种操作极大简化了集合的处理。接下来，介绍几种完结方法：</p>
<p><strong>完结方法</strong></p>
<p>“变换”过程之后，需要获取结果，即完成操作。下面我们来看相关的操作：</p>
<p><strong>匹配（Match）</strong></p>
<p>用来判断某个<code>predicate</code>是否和流对象相匹配，最终返回<code>Boolean</code>类型结果，例如：</p>
<pre>
  public static void streamMatchTest() {
    //流对象中只要有一个元素匹配就返回true
    boolean anyStartWithA = lists.stream().anyMatch((s -&gt; s.startsWith("a")));
    System.out.println(anyStartWithA);
    //流对象中每个元素都匹配就返回true
    boolean allStartWithA
        = lists.stream().allMatch((s -&gt; s.startsWith("a")));
    System.out.println(allStartWithA);
  }</pre>
<p><strong>收集（Collect）</strong></p>
<p>在对经过变换之后，我们将变换的Stream的元素收集，比如将这些元素存至集合中，此时便可以使用Stream提供的collect方法，例如：</p>
<pre>
  public static void streamCollectTest() {
    List&lt;String&gt; list = lists.stream().filter((p) -&gt; p.startsWith("a")).sorted().collect(Collectors.toList());
    System.out.println(list);

  }</pre>
<p><strong>计数（Count）</strong></p>
<p>类似sql的count，用来统计流中元素的总数，例如：</p>
<pre>
  public static void streamCountTest() {
    long count = lists.stream().filter((s -&gt; s.startsWith("a"))).count();
    System.out.println(count);
  }</pre>
<p><strong>规约（Reduce）</strong></p>
<p><code>reduce</code>方法允许我们用自己的方式去计算元素或者将一个Stream中的元素以某种规律关联，例如：</p>
<pre>
  public static void streamReduceTest() {
    Optional&lt;String&gt; optional = lists.stream().sorted().reduce((s1, s2) -&gt; {
      System.out.println(s1 + "|" + s2);
      return s1 + "|" + s2;
    });
  }</pre>
<p><strong>执行结果如下：</strong></p>
<pre>
a1|a2
a1|a2|b1
a1|a2|b1|b2
a1|a2|b1|b2|b3
a1|a2|b1|b2|b3|o1</pre>
<p><strong>并行Stream VS 串行Stream</strong></p>
<p>到目前我们已经将常用的中间操作和完结操作介绍完了。当然所有的的示例都是基于串行Stream。接下来介绍重点戏——并行Stream（parallel Stream）。并行Stream基于Fork-join并行分解框架实现，将大数据集合切分为多个小数据结合交给不同的线程去处理，这样在多核处理情况下，性能会得到很大的提高。这和MapReduce的设计理念一致：大任务化小，小任务再分配到不同的机器执行。只不过这里的小任务是交给不同的处理器。</p>
<p>通过<code>parallelStream（）</code>创建并行Stream。为了验证并行Stream是否真的能提高性能，我们执行以下测试代码：</p>
<p><strong>首先创建一个较大的集合：</strong></p>
<pre>
  List&lt;String&gt; bigLists = new ArrayList&lt;&gt;();
    for (int i = 0; i &lt; 10000000; i++) {
      UUID uuid = UUID.randomUUID();
      bigLists.add(uuid.toString());
    }</pre>
<p><strong>测试串行流下排序所用的时间：</strong></p>
<pre>
  private static void notParallelStreamSortedTest(List&lt;String&gt; bigLists) {
    long startTime = System.nanoTime();
    long count = bigLists.stream().sorted().count();
    long endTime = System.nanoTime();
    long millis = TimeUnit.NANOSECONDS.toMillis(endTime - startTime);
    System.out.println(System.out.printf("串行排序: %d ms", millis));

  }</pre>
<p><strong>测试并行流下排序所用的时间：</strong></p>
<pre>
  private static void parallelStreamSortedTest(List&lt;String&gt; bigLists) {
    long startTime = System.nanoTime();
    long count = bigLists.parallelStream().sorted().count();
    long endTime = System.nanoTime();
    long millis = TimeUnit.NANOSECONDS.toMillis(endTime - startTime);
    System.out.println(System.out.printf("并行排序: %d ms", millis));

  }</pre>
<p><strong>结果如下：</strong></p>
<p>          串行排序: 13336 ms<br />
          并行排序: 6755 ms</p>
<p>看到这里，我们确实发现性能提高了约么50%，你也可能会想以后都用<code>parallel Stream</code>不久行了么？实则不然，如果你现在还是单核处理器，而数据量又不算很大的情况下，串行流仍然是这种不错的选择。你也会发现在某些情况，串行流的性能反而更好，至于具体的使用，需要你根据实际场景先测试后再决定。</p>
<p><strong>懒操作</strong></p>
<p>上面我们谈到Stream尽可能以延迟的方式运行，这里通过创建一个无穷大的Stream来说明：</p>
<p>首先通过Stream的<code>generate</code>方法来一个自然数序列，然后通过<code>map</code>变换Stream：</p>
<pre>
 //递增序列
 class NatureSeq implements Supplier&lt;Long&gt; {
    long value = 0;

    @Override
    public Long get() {
      value++;
      return value;
    }
  }

 public void streamCreateTest() {
    Stream&lt;Long&gt; stream = Stream.generate(new NatureSeq());
    System.out.println("元素个数："+stream.map((param) -&gt; {
      return param;
    }).limit(1000).count());

  }</pre>
<p><strong>执行结果为：</strong></p>
<p>       元素个数：1000</p>
<p>我们发现开始时对这个无穷大的Stream做任何中间操作（如：<code>filter,map</code>等，但<code>sorted</code>不行）都是可以的，也就是对Stream进行中间操作并生存一个新的Stream的过程并非立刻生效的（不然此例中的<code>map</code>操作会永远的运行下去，被阻塞住），当遇到完结方法时stream才开始计算。通过<code>limit()</code>方法，把这个无穷的Stream转为有穷的Stream。</p>
<p><strong>总结</strong></p>
<p>以上就是Java Lambda快速入门详解的全部内容，看完本文后大家是不是对Java Lambda有了更深的了解，希望本文对大家学习Java Lambda能有所帮助。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索java<br />
                    ，                lambda<br />
                    ，                java8<br />
                                    lambda表达式<br />
                                    java lambda表达式、java8 lambda表达式、java中lambda表达式、java7 lambda表达式、java的lambda表达式，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 04:42:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/lambda/" title="lambda">lambda</a>, <a href="https://www.iamivan.net/tag/java8/" title="java8">java8</a>, <a href="https://www.iamivan.net/tag/lambda%e8%a1%a8%e8%be%be%e5%bc%8f/" title="lambda表达式">lambda表达式</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>快速入门Java中的Lambda表达式_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmVwRp.html" rel="bookmark">深入理解Java中的Lambda表达式&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 Java 8 开始出现,带来一个全新特性:使用 Lambda 表达式 (JSR-335) 进行函数式编程.今天我们要讨论的是 Lambda 的其中一部分:虚拟扩展方法,也叫做公共辩护(defender)方法.该特性可以让你在接口定义中提供方法的默认实现.例如你可以为已有的接口(如 List 和 Map)声明一个方法定义,这样其他开发者就无需重新实现这些方法,有点像抽象类,但实际却是接口.当然,Java 8 理论上还是兼容已有的库. 虚拟扩展方法为 Java 带来了多重继承的特性,尽管该团队声称			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodOG6M.html" rel="bookmark">在Java中使用Lambda表达式的技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本文中,我们将展示一些在 Java 8 中不太为人所了解的 Lambda 表达式技巧及其使用限制.本文的主要的受众是 Java 开发人员,研究人员以及工具库的编写人员. 这里我们只会使用没有 com.sun 或其他内部类的公共 Java API,如此代码就可以在不同的 JVM 实现之间进行移植. 快速介绍 Lambda 表达式作为在 Java 8 中实现匿名方法的一种途径而被引入,可以在某些场景中作为匿名类的替代方案. 在字节码的层面上来看,Lambda 表达式被替换成了 invokedyna			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QWDnp.html" rel="bookmark">Java函数式编程&lpar;一&rpar;：你好，Lambda表达式&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一章 你好,lambda表达式! 第一节 Java的编码风格正面临着翻天覆地的变化. 我们每天的工作将会变成更简单方便,更富表现力.Java这种新的编程方式早在数十年前就已经出现在别的编程语言里面了.这些新特性引入Java后,我们可以写出更简洁,优雅,表达性更强,错误更少的代码.我们可以用更少的代码来实现各种策略和设计模式. 在本书中我们将通过日常编程中的一些例子来探索函数式风格的编程.在使用这种全新的优雅的方式进行设计编码之前,我们先来看下它到底好在哪里. 改变了你的思考方式 命令式风格--			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeBKNb.html" rel="bookmark">Java SE 8&colon; Lambda表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java SE 8在6月13的版本中已经完全了全部的功能.在这些新的功能中,lambda表达式是推动该版本发布 的最重要新特性.因为Java第一次尝试引入函数式编程的相关内容.社区对于lambda表达式也期待已久. Lambda表达式的相关内容在JSR 335中定义,本文的内容基于最新的规范和JDK 8 Build b94. 开发环境使用 的是Eclipse. Lambda表达式 要理解lambda表达式,首先要了解的是函数式接口(functional interface).简单来说,函数式接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJq3Wp.html" rel="bookmark">技术-如何快速入门Java语言；</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何快速入门Java语言: 怎样的学习才能更快的培养Java的那种思想:对于新手学习技术科目的流程是什么; 希望得到 经验丰富的高手及老师们的指点? 解决方案 浮躁,,,学习东西得慢慢来,, 学什么东西都是孰能生巧,,做多了你就知道了,, 如果你要学Java,,你要学的东西还多着呢!!! http://blog.csdn.net/hekewangzi/article/category/2674441 解决方案二: 我正在慢慢摸索java,买了本书,先把基础掌握,确实是熟能生巧. 解决方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKq48ap.html" rel="bookmark">C&plus;&plus;中的Lambda表达式详解&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我是搞C++的 一直都在提醒自己,我是搞C++的:但是当C++11出来这么长时间了,我却没有跟着队伍走,发现很对不起自己的身份,也还好,发现自己也有段时间没有写C++代码了.今天看到了C++中的Lambda表达式,虽然用过C#的,但是C++的,一直没有用,也不知道怎么用,就可怜的连Lambda语法都看不懂.好了,这里就对C++中的Lambda进行一个简单的总结,就算是对自己的一个交代,我是搞C++的,我是一个C++ programmer. 一段简单的Code 我也不是文艺的人,对于Lambda的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3jKRNz.html" rel="bookmark">Android Studio中引入Lambda表达式的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍的是在Android Studio中引入Lambda表达式的方法,下面话不多说,来看看详细的介绍. 方法如下: 依次点击 [File][Other Settings][Default Project Structure]确保当前项目使用的JDK版本是1.8. 打开项目(Project)的build.gradle,在dependencies节点添加 classpath 'me.tatarka:gradle-retrolambda:3.2.0' 打开项目(Module)的build.grad			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdWkXdM.html" rel="bookmark">Android Studio中使用lambda表达式的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.module的build.gradle里buildTypes中添加: compileOptions { sourceCompatibility JavaVersion.VERSION_1_8 targetCompatibility JavaVersion.VERSION_1_8 } 2.module的build.gradle里defaultConfig中添加: jackOptions.enabled = true 3.注意事项:jack可能会导致中文乱码,所以需要在gradle.proper			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvY7BVb.html" rel="bookmark">Java编程中使用lambda表达式的奇技淫巧&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么使用Lambda表达式先看几个例子: 第一个例子,在一个独立的线程中执行某项任务,我们通常这么实现: class Worker implements Runnable { public void run() { for (int i = 0; i &lt; 100; i++) doWork(); } ... } Worker w = new Worker(); new Thread(w).start(); 第二个例子,自定义字符串比较的方法(通过字符串长度),一般这么做: class Lengt			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7QDaM.html" rel="bookmark" class="title">c-用   粒子群优化算法&sol;细菌觅食算法   求解下列方程 C 或者C&plus;&plus;语言或者Java都可以！</a>
					<div>
						问题描述 用 粒子群优化算法/细菌觅食算法 求解下列方程 C 或者C++语言或者Java都可以! 使用 粒子群优化算法/细菌觅食算法 求解或者优化下列方程,使用C语言或者C++语言或者Java都可以! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJl4wM.html" rel="bookmark" class="title">利用ASP脚本制作异步装载的树形结构（一）（转）&mdash;&mdash;好东东！！</a>
					<div>
						脚本|异步 树形结构是描述层次数据的常见方法.本文介绍的树形结构生成程序主要由一个ASP页面.二个JavaScript函数构成.该树形结构是异步的,也就是说,节点数据仅在必要时才读取,而不是一次性全部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdgB1M.html" rel="bookmark" class="title">从头创建 Visual Basic &period;NET 控件 &lpar;五&rpar;</a>
					<div>
						visual|创建|控件 第 4 步:绘制控件的外观要使控件具有一个可视的外观,我们需要在 Paint 事件中放置逻辑.然后,每次控件需要刷新其可视外观时,就会运行该逻辑. Windows 窗体中的  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZNjwz.html" rel="bookmark" class="title">用SqlDataAdapter更新数据库的方法介绍</a>
					<div>
						数据|数据库 其实非常简单,就是用SqlDataAdapter的update方法就行了.主要代码例如下所示:private void update() { string link = Configur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwwoQz.html" rel="bookmark" class="title">使用AJAX扩展器自定义控件（第2部分）</a>
					<div>
						目录 掩码编辑功能的必要性 MaskedEdit 扩展器 验证掩码输入 文本框自动完成 构建自动完成 Web 服务 设置 AutoComplete 扩展器的样式 对列表进行渐进式搜索 弹出式上下文菜单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Rjwdp.html" rel="bookmark" class="title">人工神经网络&lpar;Artificial Neural Netwroks&rpar;笔记-delta规则增量学习</a>
					<div>
						delta规则增量学习 Wij(t+1)=Wij(t)+α(Yj-Aj(t))Oi(t) 式中 Wij(t+1).Wij(t) 分别表示神经元ANi到ANj的联接在时刻t+1和时刻t的强度,Oi(t) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRDOqz.html" rel="bookmark" class="title">PHP超全局数组</a>
					<div>
						  这篇文章主要介绍了PHP超全局数组(Superglobals)介绍,本文讲解了概述.变量的作用域.超全局数组及注意事项等内容,需要的朋友可以参考下 概述 想做一个微信的公众平台,阅读了微信官方给的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4G8wp.html" rel="bookmark" class="title">使用jquery实现简单的ajax</a>
					<div>
						本篇文章是对用jquery实现简单的ajax的实现方法进行了详细的分析介绍,需要的朋友参考下   --&gt;html页 复制代码 代码如下: &lt;!DOCTYPE html PUBLIC &qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElXkJz.html" rel="bookmark" class="title">网页设计中的隐藏菜单示例</a>
					<div>
						  如何在网页中运用隐藏菜单提升整体设计效果,让下面这些示例来告诉你吧. 在网页设计中使用导航图标这一趋势正迫使我们再度审视导航菜单.它们在设计中的位置以及在用户体验中的角色.尽管这一理念并没有弱化其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBlPAb.html" rel="bookmark" class="title">EXCEL以冒号为参考断点截取左右两边的字符</a>
					<div>
						本教程,就您如何截取冒号左右两边的字符串,但是不要冒号. 下面先看下表. 上表中,A列中的字符串,里面分别在不相同的地方出现冒号,现在,我们要做的就是,分别截取每个单元格的冒号左边的字符和右边的字符. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWRV7b.html" rel="bookmark" class="title">error&colon;00000000&colon;lib&lpar;0&rpar;&colon;func&lpar;0&rpar;&colon;reason&lpar;0&rpar;怎么解决？</a>
					<div>
						问题描述 error:00000000:lib(0):func(0):reason(0)怎么解决? ssl_accept()函数 error:00000000:lib(0):func(0):reaso ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkne7b.html" rel="bookmark" class="title">数据抓取-c&plus;&plus;如何通过URL下载数据，在vc6的编译环境下</a>
					<div>
						问题描述 c++如何通过URL下载数据,在vc6的编译环境下 sprintf(buff%s%d%s&quot;&quot;str1numberstr2); f&lt;&lt;buff&lt;&lt;e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDY2lrb.html" rel="bookmark" class="title">第6章 访问权限控制</a>
					<div>
						引言:访问权限(或隐藏具体实现)与&quot;最初的实现并不恰当&quot;有关. 先了解两个概念: 封装(encapsulation),即隐藏对象的属性和实现细节,仅对外公开接口. 重构(Refac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6mk9b.html" rel="bookmark" class="title">KindEditor 编辑器 v3&period;5&period;1 修改版&lowbar;网页编辑器</a>
					<div>
						修改说明:1.加入分页符功能 2.修改tab事件为添加两个全角空格,更符合中国人使用习惯 如图,下载地址如下:kindeditor-3.5.1-zh_CN-kingeric.rar有几点意见及咨询:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXakjz.html" rel="bookmark" class="title">map-现在谷歌地图api还需要申请密钥吗？</a>
					<div>
						问题描述 现在谷歌地图api还需要申请密钥吗? rt.凑够30个字符.凑够30个字符.凑够30个字符.凑够30个字符.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RkVVb.html" rel="bookmark" class="title">面向对象理论</a>
					<div>
						面向对象编程举例 初步实现(面向过程的方式) 函数封装 对象封装 创建对象的方式 字面量 js var obj = { key: value, key1: value1 }; //$().css({} ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7EjkM.html" rel="bookmark" class="title">详细分析百度和Google的本质区别</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 近来网络上很多人在问百度和goog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AKXZz.html" rel="bookmark" class="title">深入剖析设计模式中的组合模式应用及在C&plus;&plus;中的实现&lowbar;C 语言</a>
					<div>
						组合模式将对象组合成树形结构以表示&quot;部分-整体&quot;的层次结构.C o m p o s i t e 使得用户对单个对象和组合对象的使用具有一致性. 模式图: 适用场景: 你想表示对象的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlRLnp.html" rel="bookmark" class="title">【SpringMVC整合MyBatis】springmvc对RESTful支持</a>
					<div>
						1.什么是RESTful RESTful架构,就是目前最流行的一种互联网软件架构.它结构清晰.符合标准.易于理解.扩展方便,所以正得到越来越多网站的采用. RESTful-表现层状态转换(即Repre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKVLXb.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;围住神经猫&rdquo;刷屏微信朋友圈 开发仅用1&period;5天</a>
					<div>
						我用了12歩围住神经猫,击败88%的人,你能超过我吗?很多微信用户发现,这两天自己的朋友圈已被一款名为围住神经猫的小游戏刷屏.点开朋友分享的链接,一只露着屁股.表情傲娇的白猫在手机屏幕中央贱贱地扭动曼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7NNLM.html" rel="bookmark" class="title">《爱在苍茫大地》开播李幼斌朱亚文上阵父子兵</a>
					<div>
						上阵父子兵 父子谈话 父子情深 朱亚文.李幼斌 新浪娱乐讯 以&quot;三线建设&quot;为背景的电视剧&lt;爱在苍茫大地&gt;于昨日(12月6日)在山东.辽宁.吉林和河南四家卫视黄金档播出, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myeg3lM.html" rel="bookmark" class="title">c-怎样按循环次数显示循环过程中的图像</a>
					<div>
						问题描述 怎样按循环次数显示循环过程中的图像 有两个cpp,a.cpp b.cpp a.cpp中是一个循环,总的循环次数是一定的.(因为程序其他功能的要求,循环的这个函数必须放在a.cpp中) for ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn548M.html" rel="bookmark" class="title">误删数据恢复</a>
					<div>
						数据平台开发误删数据,但是不知道具体时间点,就给了一个模糊时间,同事使用rollback逆向恢复(解析binlog产生反向SQL),我使用备份集恢复apply binlog正向恢复,尽快解决问题 [原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xPRrb.html" rel="bookmark" class="title">苹果对抗FBI 自由与限制的百年难题</a>
					<div>
						本周,苹果又开启了&quot;刷榜模式&quot;--几乎每一天.每一家科技媒体的头条都是有关这家公司的评论和消息.并不是苹果又发布了什么新的革命性产品,而是这一次它杠上了联邦调查局(FBI),以代表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0mYAp.html" rel="bookmark" class="title">Java排序算法总结之插入排序&lowbar;java</a>
					<div>
						本文实例讲述了Java插入排序方法.分享给大家供大家参考.具体分析如下: 有一个已经有序的数据序列,要求在这个已经排好的数据序列中插入一个数,但要求插入后此数据序列仍然有序,这个时候就要用到插入排序法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6KdPM.html" rel="bookmark" class="title">PHP5面向对象之接口技术详解</a>
					<div>
						PHP5接口语法如下: 声明一个类的时候我们使用的关键字是&quot;class&quot;,而接口一种特殊的类,使用的关键字是&quot;interface&quot;; 类的定义:class 类名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmeAxz.html" rel="bookmark" class="title">有关图片调用</a>
					<div>
						问题描述 各位大侠,我要怎么才能实现将自己网站上的图片以调用的形式发送到别的网站上去呢? 解决方案 解决方案二:是不是自己做个网站呢...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAQKDp.html" rel="bookmark" class="title">电子巨头公司力推智能穿戴设备 或掀收购热潮</a>
					<div>
						一年一度的 世界移动通信大会(MWC)将于2月24日在西班牙巴塞罗那开幕.在此前举行的国际消费电子展览会(CES)上,多家电子巨头公司力推智能穿戴设备,使得CES变成了一场&quot;穿戴展&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6YNJAb.html" rel="bookmark" class="title">WordPress博客WP&lowbar;Image&lowbar;Editor&lowbar;Imagick漏洞</a>
					<div>
						作为一名站长而言,其实早在几天之前就看到了相关资讯新闻:ImageMagick被爆高危漏洞(CVE-2016-3714),黑客等攻击者通过此漏洞可执行任意命令,最终窃取重要信息取得服务器控制权.想来对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Y47Jb.html" rel="bookmark" class="title">硅谷天堂转型三部曲：定增并购咨询权宜之计变战略</a>
					<div>
						过去两年,人民币基金开始模仿美元基金的长处:杀向TMT行业,加大投资人员对行业的了解,使自己更像产业资本而非金融资本;同时也反思自身,一位PE人士尖锐指出:很多人民币基金永远都在采取&quot;权宜之 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.057 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
